unit Common;
interface
Const
 MaxBytesInBuffer=65280;
 LowChars :string='abcdefghijklmnopqrstuvwxyz';
 HighChars:string='ABCDEFGHIJKLMNOPQRSTUVWXYZŨ';
 Epsilon=1e-16;{  }
Type
 ExtString=string[3];
 PFileBuffer=^TFileBuffer;
 TFileBuffer=array[1..MaxBytesInBuffer] of Char;
 {          
    }

 PFileReader=^TFileReader;
 TFileReader=object
              public
               constructor Init(IFileName:string);
               destructor Done;
               function EOF:boolean;
               function GetNextByte:Char;{if EOF then function returns ZERO}
              private
               FileName:string;
               Buffer:PFileBuffer;
               InFile:FILE;
               CurPosition:word;
               FileLength:longint;
               isEOF:boolean;
               HasRead:integer;{       }
             end;{TFileReader}
 PFileWriter=^TFileWriter;
 TFileWriter=object
              public
               constructor Init(IFileName:string);
               destructor Done;
               procedure Write(A:Char);
              private
               FileName:string;
               Buffer:PFileBuffer;
               OutFile:FILE;
               CurPosition:word;
             end;{TFileWriter}
 function FileExist(FileName:string):boolean;
 {True -- if File exist}
 procedure GenerateRandomName(var RNDName:string;Extention:ExtString);
 {    }
 function Max(A,B:integer):integer;
 function Min(A,B:integer):integer;
 function AllTrim(A:string):string;
 function UpCaseString(A:string):string;
 function LowCaseString(A:string):string;
 function UpCaseRu(A:Char):Char;
 function LowCaseRu(A:Char):Char;
 function Win2DosChar(A:Char):char;
 function Dos2WinChar(A:Char):char;
 function Win2DosString(A:string):string;

 function MyVal(A:string):longint;
 {  ,   ,
   -1}
 function FindRootEx(N:word;A,Eps:extended):extended;
 {  N-       Eps}
 function FindRoot(N:word;A:extended):extended;
 {  N-       Epsilon}


implementation
Var
 Win2Dos:array[byte] of byte;
 Dos2Win:array[byte] of byte;

 function FileExist(FileName:string):boolean;
 Var
  InFile:File;
  Est:boolean;
 begin
  Assign(InFile,FileName);
  Reset(InFile);
  if IOResult=0
   then Est:=True
   else Est:=False;
  if Est then Close(InFile);
  FileExist:=Est;
 end;{FileExist}
 function Max(A,B:integer):integer;
 begin
  if A>B then Max:=A
         else Max:=B;
 end;{MAX}
 function Min(A,B:integer):integer;
 begin
  if A<B then Min:=A
         else Min:=B;
 end;{Min}
 function AllTrim(A:string):string;
 Var
  Left,Right:integer;
 begin
  if Length(A)>0
   then
    begin
     Left:=1;
     Right:=Length(A);
     While (A[Left]=' ') and (Left<Right) do
      Inc(Left);
     While (A[Right]=' ') and (Left<=Right) do
      Dec(Right);
     AllTrim:=Copy(A,Left,(1+Right)-Left);
    end {THEN}
   else
    AllTrim:=A;
 end;{AllTrim}
 function UpCaseString(A:string):string;
 Var
  f:integer;
 begin
  for f:=1 to Length(A) do
   A[f]:=UpCaseRu(A[f]);
  UpCaseString:=A;
 end;{UpCaseString}
 function LowCaseString(A:string):string;
 Var
  f:byte;
 begin
  for f:=1 to Length(A) do
   A[f]:=LowCaseRu(A[f]);
  LowCaseString:=A;
 end;{LowCaseString}
 function UpCaseRu(A:Char):Char;
 Var
  Index:byte;
 begin
  Index:=Pos(A,LowChars);
  if Index=0
   then
    UpCaseRu:=A
   else
    UpCaseRu:=HighChars[Index];
 end;{UpCaseRu}
 function LowCaseRu(A:Char):Char;
 Var
  Index:byte;
 begin
  Index:=Pos(A,HighChars);
  if Index=0
   then
    LowCaseRu:=A
   else
    LowCaseRu:=LowChars[Index];
 end;{LowCaseRu}
{--------------------------TFileReader---------------------------------------}
  constructor TFileReader.Init(IFileName:string);
  begin
   FileName:=IFileName;
   if Not(FileExist(IFileName))
    then
     Fail;
   New(Buffer);
   Assign(InFile,FileName);
   Reset(InFile,1);
   CurPosition:=0;
   FileLength:=FileSize(InFile);
   HasRead:=0;
   if FileLength>0
    then isEOF:=False
    else isEOF:=True;
  end;{Init}
  destructor TFileReader.Done;
  begin
   Close(InFile);
   Dispose(Buffer);
  end;{Doen}
  function TFileReader.EOF:boolean;
  begin
   EOF:=isEOF;
  end;{EOF}
  function TFileReader.GetNextByte:Char;{if EOF then function returns ZERO}
  Var
   xResult:Char;
  begin
   xResult:=#0;
   if Not(isEOF)
    then
     begin
      if CurPosition=0
       then
        begin
         {Reading from file into buffer}
         BlockRead(InFile,Buffer^,MaxBytesInBuffer,HasRead);
         Dec(FileLength,HasRead);
         CurPosition:=1;
        end;{THEN}
      xResult:=Buffer^[CurPosition];
      Inc(CurPosition);
      if CurPosition=(1+HasRead)
       then
        begin
         CurPosition:=0;
         if FileLength=0
          then isEOF:=True;
        end;{THEN}
     end;{THEN}
   GetNextByte:=xResult;
  end;{GetNextByte}
{--------------------------TFileWriter---------------------------------------}
  constructor TFileWriter.Init(IFileName:string);
  begin
   FileName:=IFileName;
{  Misterious lines are following ]:[O]
   if Not(FileExist(IFileName))
    then
     Fail;
}
   New(Buffer);
   Assign(OutFile,FileName);
   ReWrite(OutFile,1);
   CurPosition:=0;
  end;{Init}
  destructor TFileWriter.Done;
  begin
   BlockWrite(OutFile,Buffer^,CurPosition);
   Close(OutFile);
   Dispose(Buffer);
  end;{Doen}
  procedure TFileWriter.Write(A:Char);
  begin
   inc(CurPosition);
   Buffer^[CurPosition]:=A;
   if CurPosition=MaxBytesInBuffer
    then
     begin
      {Write Buffer}
      BlockWrite(OutFile,Buffer^,MaxBytesInBuffer);
      CurPosition:=0;
     end;{THEN}
  end;{Write}

 procedure GenerateRandomName(var RNDName:string;Extention:ExtString);
 var
  f:integer;
 begin
  repeat
   RNDName:='';
   for f:=1 to 8 do
    RNDName:=RNDName+Chr(random(26)+ord('a'));
   RNDName:=RNDName+'.'+Extention;
  until Not(FileExist(RNDName));
 end;{GenerateRandomName}

 function MyVal(A:string):longint;
 Var
  Temp:integer;
  xResult:longint;
 begin
  Val(A,xResult,Temp);
  if Temp<>0 then xResult:=-1
             else if xResult<0 then xResult:=-1;
  MyVal:=xResult;
 end;{MyVal}
{$DEFINE COUNT_LOOPS}
{$UNDEF COUNT_LOOPS}
 function FindRootEx(N:word;A,Eps:extended):extended;
 Var
  LastX,X,Power:extended;
{$IFDEF COUNT_LOOPS}
  Counter:Longint;
{$ENDIF}
  function NatPower(A:extended;N:word):extended;
  Var
   Res:extended;
   f:integer;
  begin
   Res:=A;
   for f:=2 to N do
    Res:=Res*A;
   NatPower:=Res;
  end;{NatPower}
 begin
  X:=1+(A-1)/N;
{$IFDEF COUNT_LOOPS}
  Counter:=0;
{$ENDIF}
  repeat
{$IFDEF COUNT_LOOPS}
  Inc(Counter);
{$ENDIF}
   LastX:=X;
   Power:=NatPower(LastX,N-1);
   X:=LastX-(Power*LastX-A)/(N*Power);
  until ABS(X-LastX)<Eps;
  FindRootEx:=X;
{$IFDEF COUNT_LOOPS}
  Writeln('Number Of Loops ',Counter);
{$ENDIF}
 end;{FindRootEx}
 function FindRoot(N:word;A:extended):extended;
 begin
  FindRoot:=FindRootEx(N,A,Epsilon);
 end;{FindRoot}

 (*
  *     
  *)
 procedure InitWin2Dos;
 Var
  f:byte;
 begin
  for f:=0 to $FF do
   begin
    Win2Dos[f]:=f;
    Dos2Win[f]:=f;
   end;{FOR}
  Win2Dos[$C0]:=$80; Dos2Win[$80]:=$C0;
  Win2Dos[$C1]:=$81; Dos2Win[$81]:=$C1;
  Win2Dos[$C2]:=$82; Dos2Win[$82]:=$C2;
  Win2Dos[$C3]:=$83; Dos2Win[$83]:=$C3;
  Win2Dos[$C4]:=$84; Dos2Win[$84]:=$C4;
  Win2Dos[$C5]:=$85; Dos2Win[$85]:=$C5;
  Win2Dos[$A8]:=$F0; Dos2Win[$F0]:=$A8;
  Win2Dos[$C6]:=$86; Dos2Win[$86]:=$C6;
  Win2Dos[$C7]:=$87; Dos2Win[$87]:=$C7;
  Win2Dos[$C8]:=$88; Dos2Win[$88]:=$C8;
  Win2Dos[$C9]:=$89; Dos2Win[$89]:=$C9;
  Win2Dos[$CA]:=$8A; Dos2Win[$8A]:=$CA;
  Win2Dos[$CB]:=$8B; Dos2Win[$8B]:=$CB;
  Win2Dos[$CC]:=$8C; Dos2Win[$8C]:=$CC;
  Win2Dos[$CD]:=$8D; Dos2Win[$8D]:=$CD;
  Win2Dos[$CE]:=$8E; Dos2Win[$8E]:=$CE;
  Win2Dos[$CF]:=$8F; Dos2Win[$8F]:=$CF;
  Win2Dos[$D0]:=$90; Dos2Win[$90]:=$D0;
  Win2Dos[$D1]:=$91; Dos2Win[$91]:=$D1;
  Win2Dos[$D2]:=$92; Dos2Win[$92]:=$D2;
  Win2Dos[$D3]:=$93; Dos2Win[$93]:=$D3;
  Win2Dos[$D4]:=$94; Dos2Win[$94]:=$D4;
  Win2Dos[$D5]:=$95; Dos2Win[$95]:=$D5;
  Win2Dos[$D6]:=$96; Dos2Win[$96]:=$D6;
  Win2Dos[$D7]:=$97; Dos2Win[$97]:=$D7;
  Win2Dos[$D8]:=$98; Dos2Win[$98]:=$D8;
  Win2Dos[$D9]:=$99; Dos2Win[$99]:=$D9;
  Win2Dos[$DA]:=$9A; Dos2Win[$9A]:=$DA;
  Win2Dos[$DB]:=$9B; Dos2Win[$9B]:=$DB;
  Win2Dos[$DC]:=$9C; Dos2Win[$9C]:=$DC;
  Win2Dos[$DD]:=$9D; Dos2Win[$9D]:=$DD;
  Win2Dos[$DE]:=$9E; Dos2Win[$9E]:=$DE;
  Win2Dos[$DF]:=$9F; Dos2Win[$9F]:=$DF;
  Win2Dos[$E0]:=$A0; Dos2Win[$A0]:=$E0;
  Win2Dos[$E1]:=$A1; Dos2Win[$A1]:=$E1;
  Win2Dos[$E2]:=$A2; Dos2Win[$A2]:=$E2;
  Win2Dos[$E3]:=$A3; Dos2Win[$A3]:=$E3;
  Win2Dos[$E4]:=$A4; Dos2Win[$A4]:=$E4;
  Win2Dos[$E5]:=$A5; Dos2Win[$A5]:=$E5;
  Win2Dos[$B8]:=$F1; Dos2Win[$F1]:=$B8;
  Win2Dos[$E6]:=$A6; Dos2Win[$A6]:=$E6;
  Win2Dos[$E7]:=$A7; Dos2Win[$A7]:=$E7;
  Win2Dos[$E8]:=$A8; Dos2Win[$A8]:=$E8;
  Win2Dos[$E9]:=$A9; Dos2Win[$A9]:=$E9;
  Win2Dos[$EA]:=$AA; Dos2Win[$AA]:=$EA;
  Win2Dos[$EB]:=$AB; Dos2Win[$AB]:=$EB;
  Win2Dos[$EC]:=$AC; Dos2Win[$AC]:=$EC;
  Win2Dos[$ED]:=$AD; Dos2Win[$AD]:=$ED;
  Win2Dos[$EE]:=$AE; Dos2Win[$AE]:=$EE;
  Win2Dos[$EF]:=$AF; Dos2Win[$AF]:=$EF;
  Win2Dos[$F0]:=$E0; Dos2Win[$E0]:=$F0;
  Win2Dos[$F1]:=$E1; Dos2Win[$E1]:=$F1;
  Win2Dos[$F2]:=$E2; Dos2Win[$E2]:=$F2;
  Win2Dos[$F3]:=$E3; Dos2Win[$E3]:=$F3;
  Win2Dos[$F4]:=$E4; Dos2Win[$E4]:=$F4;
  Win2Dos[$F5]:=$E5; Dos2Win[$E5]:=$F5;
  Win2Dos[$F6]:=$E6; Dos2Win[$E6]:=$F6;
  Win2Dos[$F7]:=$E7; Dos2Win[$E7]:=$F7;
  Win2Dos[$F8]:=$E8; Dos2Win[$E8]:=$F8;
  Win2Dos[$F9]:=$E9; Dos2Win[$E9]:=$F9;
  Win2Dos[$FA]:=$EA; Dos2Win[$EA]:=$FA;
  Win2Dos[$FB]:=$EB; Dos2Win[$EB]:=$FB;
  Win2Dos[$FC]:=$EC; Dos2Win[$EC]:=$FC;
  Win2Dos[$FD]:=$ED; Dos2Win[$ED]:=$FD;
  Win2Dos[$FE]:=$EE; Dos2Win[$EE]:=$FE;
  Win2Dos[$FF]:=$EF; Dos2Win[$EF]:=$FF;
 end;{InitWin2Dos}
(******************************************************************************)
 (*
  *   Windows-  DOS  
  *)
 function Win2DosChar(A:Char):char;
 begin
  Win2DosChar:=char(Win2Dos[byte(A)]);
 end;{Win2DosChar}
 (******************************************************************************)
 (*
  *    Windows-  DOS
  *)
 function Win2DosString(A:string):string;
 Var
  f:integer;
 begin
  for f:=1 to Length(A) do
   A[f]:=Win2DosChar(A[f]);
  Win2DosString:=A; 
 end;{Win2DosString}
 (******************************************************************************)
 (*
  *   DOS-  Windows 
  *)
 function Dos2WinChar(A:Char):char;
 begin
  Dos2WinChar:=char(Dos2Win[byte(A)]);
 end;{Dos2WinChar}
 (******************************************************************************)
begin
 randomize;
 InitWin2Dos;
end.

